#ifndef GUARD_config_h
#define GUARD_config_h

#include "common.h"

#define SCALE_AUTO 0
#define SCALE_MIC 1
#define SCALE_MIL 2
#define SCALE_1 3
#define SCALE_K 4
#define SCALE_OZ 5
#define SCALE_LB 6
#define SCALE_STONE 7

// values for op_mode

#define MODE_DISP 0
#define MODE_QCONF 1
#define MODE_CONF 2

// misc state variables
typedef struct {
	unsigned int 
		progdiv:3,
		progress:4;
	u8 qscreen; // quick set screen
	u8 sscreen; // scale config screen
	u8 ascreen; // anyl config screen
	u8 qparam;
} state_t;

/*
// parameters for scale mode
typedef struct {
	unsigned int calunit:4, // SCALE_* for cal unit
		unit:4, // scale for display (SCALE_*)
		screen:4, // screen no. in config mode
#ifndef ADS1230
		ch:1, // which channel
#endif
		speed:1,
		burnout:2,
		extclk:2; // external clock?
	float tare; // tare, g
	u8 disp_avgs; // display averages
	float m; // cal slope, g/code
	float w_zs; // cal zero, g
	float w_fs; // cal weight in g, calculated from calweight & calscale (2 words)
} scale_parms_t;
//20 bytes
*/
// parameters for analysis mode
typedef struct {
	unsigned int speed:4,
		ch_p:4,
		ch_m:4,
		unit:3,
		tempunit:2, // 0 = deg c, 1 = deg f, 2 = hex
		extclk:2,
		pga:3,
		burnout:2,
		refsel:2,
		refin:2,
		idac0:4,
		idac1:4,
		current:4,
		dummy2:5,
		progdiv:3,
		progress:3,
		anyl_mode:2,
		mux:3,
		supply:1,
		pwrdn:1,
		console:1;
	u8 avgs;
	u8 bias;
	u8 gconfig;
	u8 gdir;
	u8 gpio;
	u8 gread;
	u8 dummy;
	xTaskHandle task;
} anyl_parms_t;
// 4 bytes

typedef struct {
	u8 mux0,
	vbias,
	mux1,
	sys0,
	ofc0,
	ofc1,
	ofc2,
	fsc0,
	fsc1,
	fsc2,
	idac0,
	idac1,
	gpiocfg,
	gpiodir,
	gpiodat;
	
} reg_parms_t;

//extern scale_parms_t sparms;
extern anyl_parms_t aparms;
extern state_t state;
extern reg_parms_t rparms;

// KEYS_MODE_AN (analysis) or KEYS_MODE_SC (scale)
extern u8 op_mode;

void config_sc(void);
void config_an(void);
void incunit(void);
void showunit(void);
void config(void);
void quickconfig(void);
void showmode(void);
void chunit(void);
void dispsetup(void);



#endif
