
#ifndef GUARD_i2c_h
#define GUARD_i2c_h

#include "common.h"

typedef enum {
	I2C_ERR_OK=0,
	I2C_ERR_NAKADR,
	I2C_ERR_NAKWR,
} I2CErr;

/*! Defines start of transfer. */
void i2cStart(void);

/*! Deines end of transfer. */
void i2cStop(void);

/*! Sends a byte to an I2C device. */
int i2cWByte(u8 b);

/*! Read a byte from an I2C device.*/
void i2cRByte(u8 *b, int ack);

/*! Sends array of length len pointed by *buf to device with address adr. Returns 
status of transfer. */
I2CErr i2cWrite(u8 adr, u8 *buf, int len);

/*! Receives an array of length len pointed by *buf to device with address adr. Returns 
status of transfer. */
I2CErr i2cRead(u8 adr, u8 *buf, int len);

/*! Reset of I2C communication. */
I2CErr i2cGCReset(void);

/*! Intialize the I2C for communication. */
void i2cInit(void);

#endif
