
#include "config.h"
#include "task.h"
#include "anyl.h"
#include "joystick.h"
#include "lcd.h"
#include "disp.h"

extern xTaskHandle core_task_handle;
#define this core_task_handle

/* QSCREEN_COUNT must equal the number of functions in the function declared below
static void (*qscreens[QSCREEN_COUNT])(void)
*/
#define QSCREEN_COUNT 10
#define QPARAM_COUNT 4


extern u8 confmode;

static int qscreen_key(void)
{
	js_evt e;



	/*if ((!aparms.ch)&&(state.qscreen==0))
		++state.qscreen;
*/
	for(;;) {
		vTaskDelay(10);
		
		while (js_have()) {
			
			
/*			if (js_pressed(JS_LEFT)) {
				confmode=MODE_CONF;
				return -1;
			}
*/
			e=js_get();
			
			if (e.held) return -1;
			if (e.jssw==JS_LEFT) {
				confmode=MODE_DISP;
				return -1;
			}
			if (e.pressed) {
				
				switch(e.jssw) {
				case JS_UP:
					++state.qscreen;

/*
					if ((!aparms.ch)&&(state.qscreen==0))
						++state.qscreen;
*/

					if (state.qscreen>=QSCREEN_COUNT)
						state.qscreen=0;
					return -1;
				case JS_DOWN:
					
				if (state.qscreen==0){
						state.qscreen=QSCREEN_COUNT-1;
				}
				else {
					state.qscreen--;
				}
					return -1;
				case JS_LEFT:
					confmode=MODE_DISP;
					return -1;
				case JS_RIGHT:
					return 0;
				default:
					break;
				}
			}
		}
	}
}

static int qparam_key(void)
{
	js_evt j;



	/*if ((!aparms.ch)&&(state.qscreen==0))
		++state.qscreen;
*/
	for(;;) {
		vTaskDelay(10);
		while (js_have()) {
/*			if (js_pressed(JS_LEFT)) {
				confmode=MODE_CONF;
				return -1;
			}
*/
			j=js_get();
			if (j.held) return -1;
			if (j.jssw==JS_LEFT) {
				//confmode=MODE_DISP;
				return -1;
			}
			if (j.pressed) {
				
				switch(j.jssw) {
				case JS_UP:
				//Turn on the device
/*					++state.qparam;

/*
					if ((!aparms.ch)&&(state.qscreen==0))
						++state.qscreen;
*/
/*
					if (state.qparam>=QPARAM_COUNT)
						state.qparam=0;
					return -1;
					
*/
					return JS_UP;
				case JS_DOWN:
				// Turn off the device
				/*					
				if (state.qparam==0){
						state.qparam=QPARAM_COUNT-1;
				}
				else {
					state.qparam--;
				}
					return -1;
					*/
					return JS_DOWN;
				case JS_LEFT:
					//confmode=MODE_DISP;
					return -1;
				case JS_RIGHT:
					// Cycle through the device list
					++state.qparam;
					if (state.qparam>=QPARAM_COUNT)
						state.qparam=0;
					return JS_RIGHT;
					
				default:
					break;
				}
			}
		}
	}
}



static const char *scr_gain_strings[8]={"  1","  2","  4","  8"," 16"," 32"," 64","128"};

static const char *scr_speed_strings[10]={"   5","  10","  20","  40","  80"," 160"," 320"," 640","1000","2000"};

static const char *scr_bo_strings[4]={" OFF","0.5uA"," 2uA","10uA"};

static const char *scr_bias_strings[8]={"IN0","IN1","IN2","IN3","IN4","IN5","IN6","IN7"};

static const char *scr_ref_strings[4]={"  0","  1","INT","I 0"};

static const char *scr_imag_strings[8]={"OFF","50u",".1 m",".25m",".5 m",".75m","1 m","1.5m"};

static const char scr_idac_strings[][5]={"AIN0","AIN1","AIN2","AIN3","AIN4","AIN5","AIN6","AIN7","IEX1","IEX2","NONE"};



static void qscr_gain(void)
{
	u8 gain=aparms.pga;
	lcd_showstr("GAIN=");
	for(;;) {
		lcd_showstr_pos((char *)scr_gain_strings[gain],5);
		if (qscreen_key()==-1) {
			aparms.pga=gain;
			return;
		}
		else ++gain;
		if (gain>7) gain=0;
	}
}


static void qscr_speed(void)
{
	u8 spd=aparms.speed;
	lcd_showstr("SPD=");
	for(;;) {
		lcd_showstr_pos((char *)scr_speed_strings[spd],4);
		if (qscreen_key()==-1) {
			aparms.speed=spd;
			return;
		}
		else ++spd;
		if (spd>9) spd=0;
	}
}
static void qscr_ch_m(void)
{
	u8 ch=aparms.ch_m;
	lcd_showstr("MUXCH-");
	for(;;) {
		lcd_showc('0'+ch,7);

		if (qscreen_key()==-1) {
			aparms.ch_m=ch;
			return;
		}
		else ++ch;

		if (ch>3)ch=0;

		
	}
}

static void qscr_ch_p(void)
{
	u8 ch=aparms.ch_p;
	lcd_showstr("MUXCH+");
	for(;;) {
		/*if (aparms.ch) {

			lcd_showstr("CHANNEL");
			lcd_showc('0'+aparms.ch,7);

		} else {
			lcd_showstr("  TEMP");
		}*/
		
		
		lcd_showc('0'+ch,7);

		if (qscreen_key()==-1) {
			aparms.ch_p=ch;
			return;
		}
		else ++ch;

		if (ch>3)ch=0;

		/*if (aparms.ch) {

			if (aparms.unit>=ANYL_UNIT_C)
				aparms.unit=ANYL_UNIT_VOLT;

		}*/

	}
}

static void qscr_bo(void)
{
	u8 bo=aparms.burnout;
	lcd_showstr("BO= ");
	for(;;) {
		lcd_showstr_pos((char *)scr_bo_strings[bo],4);
		if (qscreen_key()==-1) {
			aparms.burnout=bo;
			return;
		}
		else ++bo;
		lcd_dp_set(4,0);
		if (bo>3) bo=0;
	}
}

static void qscr_ref(void)
{
	u8 ref=aparms.refsel;
	lcd_showstr("REF=");
	for(;;) {
		lcd_showstr_pos((char *)scr_ref_strings[ref],5);
		if (qscreen_key()==-1) {
			aparms.refsel=ref;
			if (ref>1){
				aparms.refin=1;
			}
			return;
		}
		else ++ref;
		lcd_dp_set(5,0);
		if (ref==1) ++ref;
		if (ref>3) ref=0;
	}
}

static void qscr_idac1(void)
{
	u8 dac=aparms.idac0;
	lcd_showstr("I1=");
	for(;;) {
		lcd_showstr_pos((char *)scr_idac_strings[dac],4);
		if (qscreen_key()==-1) {
			aparms.idac0=dac;
			if (dac<10){
				aparms.refin=1;
			}
			return;
		}
		else ++dac;
		//lcd_dp_set(5,0);
		if (dac>3 && dac<10) dac=10;
		if (dac>10) dac=0;
	}
}

static void qscr_idac2(void)
{
	u8 dac=aparms.idac1;
	lcd_showstr("I2=");
	for(;;) {
		lcd_showstr_pos((char *)scr_idac_strings[dac],4);
		if (qscreen_key()==-1) {
			aparms.idac1=dac;
			if (dac<10){
				aparms.refin=1;
			}
			return;
		}
		else ++dac;
		//lcd_dp_set(5,0);
		if (dac>3 && dac<10) dac=10;
		if (dac>10) dac=0;
	}
}



static void qscr_imag(void)
{
	u8 imag=aparms.current;
	lcd_showstr("CUR=");
	for(;;) {
		lcd_showstr_pos((char *)scr_imag_strings[imag],5);
		if (qscreen_key()==-1) {
			aparms.current=imag;
			if (imag>0){
				aparms.refin=1;
			}
			return;
		}
		else ++imag;
		lcd_dp_set(4,0);
		lcd_dp_set(5,0);
		if (imag>7) imag=0;
	}
}


static void qscr_bias(void)
{
	int key=0;
	u8 bb;
	u8 bias=aparms.bias;
	lcd_showstr("BIAS ? ");
	for(;;) {
		

		if (qscreen_key()==-1) {
			
			return;
		}
		lcd_showstr_pos((char *)scr_bias_strings[state.qparam],5);
		
		bb= (bias>>state.qparam)&0x01;
		if (bb) lcd_showstr_pos("ON ",2);
		else lcd_showstr_pos("OFF",2);
		
		for(;;) {
	
			//turn on all the arrows
			
			//lcd_arrowset(0,1);	//left	
			
			key=qparam_key();
			if (key == -1) {
				lcd_showstr("BIAS ?");
				aparms.bias=bias;
				
				break;
				
			}
			switch(key){
				case JS_UP:
					
					bias=bias|(0x01 << state.qparam);
					bb= (bias>>state.qparam)&0x01;
					if (bb)lcd_showstr_pos("ON ",2) ;
					else lcd_showstr_pos("OFF",2);
					break;
					
				case JS_DOWN:
					
					bias=bias&~(0x01<< state.qparam);
					bb= (bias>>state.qparam)&0x01;
					if (bb)lcd_showstr_pos("ON ",2) ;
					else lcd_showstr_pos("OFF",2);
					break;
				case JS_RIGHT: // cycle through list
					lcd_showstr_pos((char *)scr_bias_strings[state.qparam],5);
					bb= (bias>>state.qparam)&0x01;
					if (bb) lcd_showstr_pos("ON ",2);
					else lcd_showstr_pos("OFF",2);
				default:
					break;
			}
			
		
	}
	js_waitrelease();
}
}

/* QSCREEN_COUNT from definition above must match the number of functions below */
static void (*qscreens[QSCREEN_COUNT])(void)={

	qscr_gain,
	qscr_speed,
	qscr_ch_p,
	qscr_ch_m,
	qscr_bo,
	qscr_bias,
	qscr_ref,
	qscr_imag,
	qscr_idac1,
	qscr_idac2
};

void quickconfig(void)
{
	confmode=MODE_QCONF;
	for(;;) {
		lcd_arrowset(0,1);
		qscreens[state.qscreen]();
		if (confmode!=MODE_QCONF) break;
	}
	//turn off left arrow only
				lcd_arrowset(1,0);	//left off
				lcd_arrowset(2,1);
				lcd_arrowset(3,1);
	if (confmode==MODE_CONF)
			config();
	
}

static const char *anylmodestrs[4]={"RAW","RMS","P-P","AVG"};
static const char *tempstrs[3]={" \177C"," \177F","HEX"};

void showmode(void)
{
	lcd_showstr((char *)anylmodestrs[aparms.anyl_mode]);
	switch(aparms.unit) {
	case ANYL_UNIT_HEX:
		lcd_showstr_pos("HEX",5);
		break;
	default:
		lcd_showstr_pos("DEC",5);
		break;
	case ANYL_UNIT_VOLT:
		lcd_showstr_pos("VOLT",4);
		break;
	case ANYL_UNIT_ENOB:
		lcd_showstr_pos("ENOB",4);
		break;

	case ANYL_UNIT_C:
		lcd_showstr_pos("\177C",6);
		break;
	case ANYL_UNIT_F:
		lcd_showstr_pos("\177F",6);
		break;

	}
}

static void chmode(void)
{
	u8 mode=aparms.anyl_mode+1;
	if (mode>3) mode=0;
	switch(mode) {
	case ANYL_MODE_RAW:
		if (aparms.unit==ANYL_UNIT_ENOB)
			aparms.unit=ANYL_UNIT_VOLT;
	case ANYL_MODE_RMSN:
	case ANYL_MODE_PEAK:
		if (aparms.unit==ANYL_UNIT_HEX)
			aparms.unit=ANYL_UNIT_DEC;
		else if (aparms.unit>3)
			aparms.unit=1;
		break;
	case ANYL_MODE_AVG:
		if (aparms.unit==ANYL_UNIT_HEX||aparms.unit==ANYL_UNIT_ENOB)
			aparms.unit=ANYL_UNIT_DEC;
	default:
		break;
	}
	aparms.anyl_mode=mode;
}

void chunit(void)
{
	++aparms.unit;
	switch(aparms.anyl_mode) {
	case ANYL_MODE_RAW:

		/*if (aparms.ch) {

			if (aparms.unit==ANYL_UNIT_ENOB)
				aparms.unit=ANYL_UNIT_HEX;

		} else {
			if (aparms.unit==ANYL_UNIT_ENOB)
				aparms.unit=ANYL_UNIT_C;
			else if (aparms.unit>ANYL_UNIT_F)
				aparms.unit=ANYL_UNIT_HEX;
		}*/
		if (aparms.unit==ANYL_UNIT_ENOB)
				aparms.unit=ANYL_UNIT_HEX;


		break;
	case ANYL_MODE_AVG:
		if (aparms.unit==ANYL_UNIT_HEX)
			aparms.unit=ANYL_UNIT_DEC;
		else

		//if (aparms.ch)

		{
			if (aparms.unit==ANYL_UNIT_ENOB)
				aparms.unit=ANYL_UNIT_DEC;
		}
		/*else {
			if (aparms.unit==ANYL_UNIT_ENOB)
				aparms.unit=ANYL_UNIT_C;
			else if (aparms.unit>ANYL_UNIT_F)
				aparms.unit=ANYL_UNIT_HEX;
		}*/

		break;
	case ANYL_MODE_RMSN:
	case ANYL_MODE_PEAK:
		if (aparms.unit==ANYL_UNIT_HEX)
			aparms.unit=ANYL_UNIT_DEC;
		else if (aparms.unit>ANYL_UNIT_ENOB)
			aparms.unit=ANYL_UNIT_DEC;
		break;
	default:
		break;
	}
}

void dispsetup(void)
{
	js_evt e;
	
	
	for(;;) {
		showmode();
		lcd_arrowset(1,0);	//up
		lcd_arrowset(3,1);	//down
		lcd_arrowset(0,1);	//left	
		vTaskDelay(10);
		if (js_have()) {
			if (js_pressed(JS_LEFT)) {
				//confmode=MODE_CONF;
				
				return;
			}
			e=js_get();
			/*if (!e.pressed&&e.jssw==KEYS_CAL) {
				config_an();
				return;
			}*/
			if (e.pressed&!e.held) {
				switch(e.jssw) {
				case JS_UP:
					chmode();
					break;
				case JS_DOWN:
					chunit();
					break;
				default:
					break;
				}
			}
		}
	}
}
